#include <iostream>
#include <cstdlib>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <set>
#include <queue>
#include <cstring>
#include <sstream>
#include <stack>
#include <deque>
#include <cmath>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;

#define EPS 1e-9


struct plane{
	int startplanet, speed, priceforkilometer, capacity;
} planes[52];
int n, m, f;

queue <int> forshortpath;

struct schedule{
	int sh, eh, month, winperpasngr, passengers;
};

struct flight{
	int from;
	int to;
	int dist;
	vector <schedule> schedules;
} flights[1001];

//susedi na planetite (indeks v flights)
vector <int> nbs[52];

void readinput()
{
	scanf("%d %d %d", &n, &m, &f);
	for (int i = 0; i < m; ++i)
		scanf("%d %d %d %d", &planes[i].startplanet, &planes[i].speed, &planes[i].priceforkilometer, &planes[i].capacity),
		forshortpath.push(planes[i].startplanet);
	int ai, bi, di, ki;
	schedule tmp;
	for (int i = 0; i < f; ++i)
	{
		scanf("%d %d %d %d", &ai, &bi, &di, &ki);
		flights[i].from = ai;
		flights[i].to = bi;
		flights[i].dist = di;
		nbs[ai].push_back(i);
		for (int j = 0; j < ki; ++j)
		{
			scanf("%d %d %d %d %d", &tmp.sh, &tmp.eh, &tmp.month, &tmp.winperpasngr, &tmp.passengers);
			flights[i].schedules.push_back(tmp);
		}
	}
}

double time(int dist, int speed) {
	return (double)dist/((double)speed); }

/*
for each plane make dijkstra to find shortest cycle,
*/

struct mycomp
{
	bool operator () (const pair <int, int> & a, const pair <int, int> & b) const { return a.second > b.second; }
};

#define pii pair<int,int>
#define INF 1000000000

vector <flight> part(51);
int dist[51];
void solve(int plan)
{
	part.resize(51);
	bool marked[51];
	memset(marked, 0, sizeof(marked));
	for (int i = 0; i < 51; ++i) dist[i] = INF;
	int from = planes[plan].startplanet;
	priority_queue <pii, vector <pii>, mycomp > q;
	for (int i = 0; i < nbs[from].size(); ++i)	q.push(make_pair(nbs[from][i], flights[nbs[from][i]].dist)), part[flights[nbs[from][i]].to] = flights[nbs[from][i]], dist[flights[nbs[from][i]].to] = flights[nbs[from][i]].dist;
	while (!q.empty())
	{
		int tp = q.top().first;
		q.pop();
		int vruh = flights[tp].to;
		for (int i = 0; i < nbs[vruh].size(); ++i)
		{
			int to = flights[nbs[vruh][i]].to;
			if (dist[to] > dist[vruh] + flights[nbs[vruh][i]].dist)
			{
				dist[to] = dist[vruh] + flights[nbs[vruh][i]].dist;
				part[to] = flights[nbs[vruh][i]];
				q.push(make_pair(to, dist[to]));
			}
		}
	}
}


struct dayhourplanet{
	int d, h, p;
	dayhourplanet(int d=0,int h=0, int p=0) : d(d), h(h),p(p) {}
};

struct colission{
	int fr, to, day, hour;;
	colission(int f, int t, int d, int h): fr(f), to(t), day(d), hour(h) {}
	bool operator < (const colission & b) const {
		if (fr == b.fr && to == b.to && day == b.day) return hour < b.hour;
		if (fr == b.fr && to == b.to) return day < b.day;
		if (fr == b.fr) return to < b.to;
		return fr < b.fr;
	}
};


int main()
{
	freopen("flights.in", "r", stdin);
	freopen("flights.out", "w", stdout);
	readinput();
	set <colission> cols;
	for (int i = 0; i < m; ++i)
	{
		vector <dayhourplanet> res;
		double fly_time = 4.0;
		double arival_time;
		int day = 1;
		solve(i);
		int plan = planes[i].startplanet;
		vector <flight> path;//edges in path
		path.push_back(part[plan]);
		int curplan = part[plan].from;
		while (curplan != plan)
		{
			path.push_back(part[curplan]);
			curplan = part[curplan].from;
		}
		reverse(path.begin(), path.end());
		arival_time = fly_time + time(path[0].dist, planes[i].speed);
		for (int j = 0; j < (int) path.size() - 1; ++j)
		{
			while (cols.count(colission(path[j].from, path[j].to, day, static_cast <int> (fly_time+EPS))) > 0)
			{
				
				fly_time += 1.0;
				arival_time += 1.0;
				if (arival_time > 16.0-EPS)
				{
					fly_time = 4.0;
					arival_time = fly_time + time(path[j].dist, planes[i].speed);
					day++;
				}
				
			}
			res.push_back(dayhourplanet(day, static_cast <int> (fly_time+EPS), path[j].to));
			cols.insert(colission(path[j].from, path[j].to, day, static_cast <int> (fly_time+EPS)));
			fly_time = ceil(arival_time);
			arival_time = fly_time + time(path[j+1].dist, planes[i].speed);
			if (arival_time > 16.0-EPS)
			{
				day++;
				fly_time = 4.0;
				arival_time = fly_time + time(path[j+1].dist, planes[i].speed);
			}
		}
		while (cols.count(colission(path[path.size() - 1].from, path[path.size() - 1].to, day, static_cast <int> (fly_time+EPS))) > 0)
		{
			
			fly_time += 1.0;
			arival_time += 1.0;
			if (arival_time > 16.0-EPS)
			{
				fly_time = 4.0;
				arival_time = fly_time + time(path[path.size() - 1].from, planes[path.size() - 1].speed);
				day++;
			}
			
		}
		res.push_back(dayhourplanet(day, static_cast <int> (fly_time+EPS), path[path.size() - 1].to));
		cols.insert(colission(path[path.size() - 1].from, path[path.size() - 1].to, day, static_cast <int> (fly_time+EPS)));
		printf("%d\n", res.size());
		day = 1;
		for (int j = 0; j < res.size(); j++)
			printf("%d %d %d\n", day++, res[j].h, res[j].p);
	}
	
	return 0;
}